      program m_icon
c
      dimension angle(91),vt1p12(91),vt2p12(91),vlp12(91),
     *                    vt1p23(91),vt2p23(91),vlp23(91),
     *                    vt1p13(91),vt2p13(91),vlp13(91)
      common /plot/ vlxg(273),vlyg(273),
     *             vt2xg(273),vt2yg(273),
     *             vt1xg(273),vt1yg(273)
c
      open(5,file='dw2ds.data', status='old',err=8888)
      open(6,file='icon.out',status='unknown'
     *,form='unformatted',err=8888)
c
      betad=30.0
c
      pi=acos(-1.)
c
      call in(rho,c11,c22,c33,c44,c55,c66,c12,c13,c23)
      del=pi/180.
      thetar=0.0
c
      do 1000 iang=1,91
      angle(iang)=thetar*(180./pi)
      c=cos(thetar)
      s=sin(thetar)
      c2=c**2
      s2=s**2 
c
c         x1-x2 plane
c
c  t
      arg=(c44*s2+c55*c2)/rho
      vt1p12(iang)=sqrt(arg)
c  qt
      arg1=c66+c11*c2+c22*s2
      arg2=(c11*c2+c66*s2)*(c66*c2+c22*s2)-(c12+c66)**2*c2*s2
      arg3=(c66+c11*c2+c22*s2)**2-4.*arg2
      arg4=sqrt(arg3)
      arg5=(arg1-arg4)/(2.*rho)
      vt2p12(iang)=sqrt(arg5)
c  ql
      arg5=(arg1+arg4)/(2.*rho)
      vlp12(iang)=sqrt(arg5)
c
c         x2-x3 plane
c
c   t
      arg=(c66*c2+c55*s2)/rho
      vt1p23(iang)=sqrt(arg)
c  qt
      arg1=c44+c22*c2+c33*s2
      arg2=(c22*c2+c44*s2)*(c44*c2+c33*s2)-(c23+c44)**2*c2*s2
      arg3=(c44+c22*c2+c33*s2)**2-4.*arg2
      arg4=sqrt(arg3)
      arg5=(arg1-arg4)/(2.*rho)
      vt2p23(iang)=sqrt(arg5)
c  ql
      arg5=(arg1+arg4)/(2.*rho)
      vlp23(iang)=sqrt(arg5)
c
c          x1-x3 plane 
c
c   t
      arg=(c44*s2+c66*c2)/rho
      vt1p13(iang)=sqrt(arg)
c  qt
      arg1=c55+c11*c2+c33*s2
      arg2=(c11*c2+c55*s2)*(c55*c2+c33*s2)-(c13+c55)**2*c2*s2
      arg3=(c55+c11*c2+c33*s2)**2-4.*arg2
      arg4=sqrt(arg3)
      arg5=(arg1-arg4)/(2.*rho)
      vt2p13(iang)=sqrt(arg5)
c  ql
      arg5=(arg1+arg4)/(2.*rho)
      vlp13(iang)=sqrt(arg5)
c
c  increment angle
c
      thetar=thetar+del
c
 1000 continue
c
c  end loop on theta (0 thru 90)
c
c   map v1,vt2 and vt1 into global isometric coord.s
c
      beta=betad*pi/180.
c
c  x1-x2 plane mapped into global coord.s
c
      do 1020 i=1,91
c
      theta=(i-1)*del
      iplane=1
      fact1=factor1(theta,beta,iplane)
      fact2=factor2(theta,beta,iplane)
c
c vl
      vlxg(i)=vlp12(i)*fact1
      vlyg(i)=vlp12(i)*fact2
c
c vt2
      vt2xg(i)=vt2p12(i)*fact1
      vt2yg(i)=vt2p12(i)*fact2
c
c vt1
      vt1xg(i)=vt1p12(i)*fact1
      vt1yg(i)=vt1p12(i)*fact2
c
 1020 continue
c
c  x2-x3 plane mapped into global coord.s
c
      do 2030 i=92,182
c
      theta=(i-92)*del
      iplane=2
      fact1=factor1(theta,beta,iplane)
      fact2=factor2(theta,beta,iplane)
c
c vl
      vlxg(i)=vlp23(i-91)*fact1
      vlyg(i)=vlp23(i-91)*fact2
c
c vt2
      vt2xg(i)=vt2p23(i-91)*fact1
      vt2yg(i)=vt2p23(i-91)*fact2
c
c vt1
      vt1xg(i)=vt1p23(i-91)*fact1
      vt1yg(i)=vt1p23(i-91)*fact2
c
 2030 continue
c
c  x1-x3 plane mapped into global coord.s
c
      do 1030 i=183,273
c
      theta=(273-i)*del
      iplane=3
      fact1=factor1(theta,beta,iplane)
      fact2=factor2(theta,beta,iplane)
c
c vl
      vlxg(i)=vlp13(274-i)*fact1
      vlyg(i)=vlp13(274-i)*fact2
c
c vt2
      vt2xg(i)=vt2p13(274-i)*fact1
      vt2yg(i)=vt2p13(274-i)*fact2
c
c vt1
      vt1xg(i)=vt1p13(274-i)*fact1
      vt1yg(i)=vt1p13(274-i)*fact2
c
 1030 continue
c
c   write transformations to output files
c
      write(6)vlxg
      write(6)vt2xg
      write(6)vt1xg
      write(6)vlyg
      write(6)vt2yg
      write(6)vt1yg
 8888 stop
      end
C
C#######################################################################
      SUBROUTINE IN(RHO,C11,c22,c33,c44,c55,c66,c12,c13,c23)
C
C  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C  *  SUBROUTINE IN:                                                 *
C  *     READS MATERIAL DENSITY AND STIFFNESSES FROM THE INPUT FILE  *
C  *     AND STORES MATERIAL INFO. AS ALPHANUMERIC DATA IN LABELED   *
C  *     COMMON /K/ TO BE PLOTTED AS A HEADER ABOVE EACH PLOT.       *
C  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
      CHARACTER MTYPE*24,ICOM*24,IDEN*20,ISU*10
      COMMON /K/MTYPE,ICOM,IDEN,ISU
      dimension C(6,6)
C
C   ZERO ALL STIFFNESSES
C
      DO 10 I=1,6
      DO 10 J=1,6
      C(I,J)=0.0
   10 CONTINUE
C
C  READ MATERIAL TYPE AND COMMENT FROM INPUT FILE 
      READ(5,1)MTYPE,ICOM
    1 FORMAT(/,A24,/,A24)
C
C   READ MATERIAL DENSITY, UNITS OF STIFFNESSES AND
C  NO. OF INDEPENDENT STIFFNESS TERM FROM INPUT FILE
      READ(5,4)IDEN,RHO,ISU,NS
    4 FORMAT(A20,E10.3,/,16X,A10,/,31X,I2)
C
C  LOOP THRU AND READ NO. OF INDEPENDENT STIFFNESS TERMS
C                     FROM INPUT FILE
      DO 6 II=1,NS
      READ(5,5)I,J,C(I,J)
    5 FORMAT(1X,I1,I1,1X,E10.3)
    6 CONTINUE
      READ(5,7)MS
    7 FORMAT(30X,I2)
C
C  LOOP THRU AND READ NO. OF REMAINING STIFFNESS TERMS
C                  FROM INPUT FILE
      DO 8 II=1,MS
      READ(5,5)I,J,C(I,J)
    8 CONTINUE
c
      c11=c(1,1)
      c22=c(2,2)
      c33=c(3,3)
      c44=c(4,4)
      c55=c(5,5)
      c66=c(6,6)
      c12=c(1,2)
      c13=c(1,3)
      c23=c(2,3)
C
      RETURN
      END 
C
C#######################################################################
c
      function factor1(a,b,i)
      factor1=(sin(a)-cos(a))*cos(b)
      if(i.eq.2)factor1=cos(a)*cos(b)
      if(i.eq.3)factor1=-cos(a)*cos(b)
      return
      end
C
C#######################################################################
c
      function factor2(a,b,i)
      factor2=-(cos(a)+sin(a))*sin(b)
      if(i.eq.2)factor2=sin(a)-cos(a)*sin(b)
      if(i.eq.3)factor2=sin(a)-cos(a)*sin(b)
      return
      end
